import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import UtenteAppService from '@/entities/utente-app/utente-app.service';
import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import MessaggioUpdate from './messaggio-update.vue';
import MessaggioService from './messaggio.service';

type MessaggioUpdateComponentType = InstanceType<typeof MessaggioUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const messaggioSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<MessaggioUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('Messaggio Management Update Component', () => {
    let comp: MessaggioUpdateComponentType;
    let messaggioServiceStub: SinonStubbedInstance<MessaggioService>;

    beforeEach(() => {
      route = {};
      messaggioServiceStub = sinon.createStubInstance<MessaggioService>(MessaggioService);
      messaggioServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          messaggioService: () => messaggioServiceStub,
          utenteAppService: () =>
            sinon.createStubInstance<UtenteAppService>(UtenteAppService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(MessaggioUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(MessaggioUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.messaggio = messaggioSample;
        messaggioServiceStub.update.resolves(messaggioSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(messaggioServiceStub.update.calledWith(messaggioSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        messaggioServiceStub.create.resolves(entity);
        const wrapper = shallowMount(MessaggioUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.messaggio = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(messaggioServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        messaggioServiceStub.find.resolves(messaggioSample);
        messaggioServiceStub.retrieve.resolves([messaggioSample]);

        // WHEN
        route = {
          params: {
            messaggioId: `${messaggioSample.id}`,
          },
        };
        const wrapper = shallowMount(MessaggioUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.messaggio).toMatchObject(messaggioSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        messaggioServiceStub.find.resolves(messaggioSample);
        const wrapper = shallowMount(MessaggioUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
